unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_SxXnKcList, U_KkAndDjList, U_OrderProgress, U_AllOrderProgress,
  U_OrderProgressDay, U_OrderProgressDay_KC, U_CJOrderProgressDay2,
  U_CZOrderProgressDay, U_DyeCardList, U_OrderProgressMonth;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if Trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
//  server := '.';
    dtbase := 'CHENFENGdata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;

  end
  else
    DConString := DataBaseStr;
  // DName:='周高祥';
   //DParameters1:='高权限';   //高权限
   //DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //开卡与打卷对比
      begin
        if frmKkAndDjList = nil then
        begin
          frmKkAndDjList := TfrmKkAndDjList.Create(application.MainForm);
          with frmKkAndDjList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmKkAndDjList.BringToFront;
       //句柄
        mnewHandle := frmKkAndDjList.Handle;
      end;
    121:  //跟进表
      begin
        if frmOrderProgress = nil then
        begin
          frmOrderProgress := TfrmOrderProgress.Create(application.MainForm);
          with frmOrderProgress do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgress.BringToFront;
       //句柄
        mnewHandle := frmOrderProgress.Handle;
      end;
    131:  //总跟进表
      begin
        if frmAllOrderProgress = nil then
        begin
          frmAllOrderProgress := TfrmAllOrderProgress.Create(application.MainForm);
          with frmAllOrderProgress do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmAllOrderProgress.BringToFront;
       //句柄
        mnewHandle := frmAllOrderProgress.Handle;
      end;
    140:  //日产值表
      begin
        if frmCZOrderProgressDay = nil then
        begin
          frmCZOrderProgressDay := TfrmCZOrderProgressDay.Create(application.MainForm);
          with frmCZOrderProgressDay do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCZOrderProgressDay.BringToFront;
       //句柄
        mnewHandle := frmCZOrderProgressDay.Handle;
      end;
    141:  //月产量报表
      begin
        if frmOrderProgressmonth = nil then
        begin
          frmOrderProgressmonth := TfrmOrderProgressmonth.Create(application.MainForm);
          with frmOrderProgressmonth do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgressmonth.BringToFront;
       //句柄
        mnewHandle := frmOrderProgressmonth.Handle;
      end;
//    141:  //月产量报表
//      begin
//        if frmOrderProgressDay = nil then
//        begin
//          frmOrderProgressDay := TfrmOrderProgressDay.Create(application.MainForm);
//          with frmOrderProgressDay do
//          begin
//            caption := Trim(Title);
//            FormStyle := mstyle;
//            windowState := mstate;
//            BorderStyle := mborderstyle;
//           //show;
//          end;
//        end
//        else
//          frmOrderProgressDay.BringToFront;
//       //句柄
//        mnewHandle := frmOrderProgressDay.Handle;
//      end;
    142:  //日库存报表
      begin
        if frmOrderProgressDay_KC = nil then
        begin
          frmOrderProgressDay_KC := TfrmOrderProgressDay_KC.Create(application.MainForm);
          with frmOrderProgressDay_KC do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgressDay_KC.BringToFront;
       //句柄
        mnewHandle := frmOrderProgressDay_KC.Handle;
      end;

    143:  //车间日产量报表
      begin
        if frmCJOrderProgressDay2 = nil then
        begin
          frmCJOrderProgressDay2 := TfrmCJOrderProgressDay2.Create(application.MainForm);
          with frmCJOrderProgressDay2 do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCJOrderProgressDay2.BringToFront;
       //句柄
        mnewHandle := frmCJOrderProgressDay2.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Statistics) then
    DataLink_Statistics := TDataLink_Statistics.Create(Application);
  try
    with DataLink_Statistics.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;
//
//initialization
//  OldDllApp := Application;
//
//
//finalization
//  DataLink_Statistics.Free;
//  Application := OldDllApp;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_Statistics.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

